#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <inttypes.h>

#define NMAX 28

/* Definition of subtask */

typedef struct {
  int id ;
  int n ;
  int depth ;
  int seen[NMAX] ;
} subtask_t ;

subtask_t *copy_arg(subtask_t *z) ;
void free_arg(subtask_t *z) ;

void print_subtask(FILE *fp,subtask_t *z) ;
subtask_t *read_subtask(FILE *fp) ;

/* Result (unsigned 64 bits integer */
typedef uint64_t count_t ;
#define PRC PRIu64


/* Type of subtasks handlers:
   - env is the task generator homonymous argument
   - z is a task to handle */
typedef void emit_t(void *env,subtask_t *z) ;


/* Task generator, returns number of tasks generated.
   Will call emit on all generated tasks */
int generate_subtasks(int n, int depth,void *env, emit_t emit) ;

/* Run a subtask */
count_t run_subtask(subtask_t *z) ;
